profunctors-5.2.1: Profunctors

Copyright | (C) 2015 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable, MPTCs, fundeps
Safe Haskell | Safe
Language | Haskell2010

Data.Profunctor.Adjunction

Description

Synopsis

- class (ProfunctorFunctor f, ProfunctorFunctor u) => ProfunctorAdjunction f u | f -> u, u -> f where

# Documentation

class (ProfunctorFunctor f, ProfunctorFunctor u) => ProfunctorAdjunction f u | f -> u, u -> f where Source #

Laws:

    unit . counit ≡ id
    counit . unit ≡ id

Minimal complete definition

unit, counit

Methods

unit :: Profunctor p => p :-> u (f p) Source #

counit :: Profunctor p => f (u p) :-> p Source #

Instances

ProfunctorAdjunction Copastro Cotambara Source # |
Methods unit :: Profunctor p => p :-> Cotambara (Copastro p) Source # counit :: Profunctor p => Copastro (Cotambara p) :-> p Source #
ProfunctorAdjunction Pastro Tambara Source # |
Methods unit :: Profunctor p => p :-> Tambara (Pastro p) Source # counit :: Profunctor p => Pastro (Tambara p) :-> p Source #
ProfunctorAdjunction CopastroSum CotambaraSum Source # |
Methods unit :: Profunctor p => p :-> CotambaraSum (CopastroSum p) Source # counit :: Profunctor p => CopastroSum (CotambaraSum p) :-> p Source #
ProfunctorAdjunction PastroSum TambaraSum Source # |
Methods unit :: Profunctor p => p :-> TambaraSum (PastroSum p) Source # counit :: Profunctor p => PastroSum (TambaraSum p) :-> p Source #
ProfunctorAdjunction Environment Closure Source # |
Methods unit :: Profunctor p => p :-> Closure (Environment p) Source # counit :: Profunctor p => Environment (Closure p) :-> p Source #
ProfunctorAdjunction (Procompose p) (Rift p) Source # |
Methods unit :: Profunctor p => p :-> Rift p (Procompose p p) Source # counit :: Profunctor p => Procompose p (Rift p p) :-> p Source #